Index: /vtcross/trunk/src/include/vtcross/components.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/components.h	(revision 207)
+++ /vtcross/trunk/src/include/vtcross/components.h	(revision 208)
@@ -343,5 +343,5 @@
         bool CE_present;
        
-	int32_t numberOfCognitiveEngines; 
+        int32_t numberOfCognitiveEngines; 
         int16_t primaryPort;
         int16_t policyPort;
Index: /vtcross/trunk/src/shell/CognitiveRadioShell.cpp
===================================================================
--- /vtcross/trunk/src/shell/CognitiveRadioShell.cpp	(revision 207)
+++ /vtcross/trunk/src/shell/CognitiveRadioShell.cpp	(revision 208)
@@ -124,5 +124,5 @@
     numberOfCognitiveEngines--;
     if(numberOfCognitiveEngines == 0)
-	CE_present = false;
+    CE_present = false;
 
     SendMessage(socketFD, "deregister_ack");
@@ -216,5 +216,5 @@
         const char *uName = pChild->Attribute("name");
         if(uName)
-            uList[item_count].name = uName;	
+            uList[item_count].name = uName;    
 
         const char *uUnits = pChild->Attribute("units");
@@ -232,5 +232,5 @@
     }
 
-    radio_info->numUtilities = item_count;	
+    radio_info->numUtilities = item_count;    
     LOG("Cognitive Radio Shell:: Parsed %d utilities.\n", radioInfo->numUtilities);
 
@@ -245,5 +245,5 @@
         if(oName) 
             oList[item_count].name = oName;
-		
+        
         affect_count = 0;
         for(pSecondChild = pChild->FirstChildElement("affect"); pSecondChild; \
@@ -273,5 +273,5 @@
             }
             else
-                match_found = false;	
+                match_found = false;    
         }
         oList[item_count].numAffects = affect_count; 
@@ -279,10 +279,10 @@
     }
 
-    radioInfo->numObservables = item_count;	
+    radioInfo->numObservables = item_count;    
     LOG("Cognitive Radio Shell:: Parsed %d observables.\n", radioInfo->numObservables);
 
     pElem = hRoot.FirstChild("parameters").Element();
     pChild1 = hRoot.Child("parameters", count).Element();
-	
+    
     item_count = 0;
     for(pChild = pChild1->FirstChildElement("parameter"); pChild; \
@@ -291,5 +291,5 @@
         const char *pName = pChild->Attribute("name");
         if(pName) 
-            pList[item_count].name = pName;	
+            pList[item_count].name = pName;    
 
         const char *pUnits = pChild->Attribute("units");
@@ -305,5 +305,5 @@
         if(pChild->QueryFloatAttribute("step", &pList[item_count].step) != TIXML_SUCCESS) 
             pList[item_count].step = -1;
-		
+        
         affect_count = 0;
         for(pSecondChild = pChild->FirstChildElement("affect"); pSecondChild; \
@@ -317,5 +317,5 @@
                     if(uList[attribute_count].name == pUtilName) 
                     {
-                        pList[item_count].affection_list[affect_count].u = &uList[attribute_count];	
+                        pList[item_count].affection_list[affect_count].u = &uList[attribute_count];    
 
                         const char *pRelate = pSecondChild->Attribute("relationship");
@@ -338,5 +338,5 @@
             }
 
-            match_found = false;	
+            match_found = false;    
         }
 
@@ -367,18 +367,18 @@
 
     if(strcmp(buffer,"register_engine_cognitive") == 0) { 
-	    RegisterCognitiveEngine(socketFD);
+        RegisterCognitiveEngine(socketFD);
     } else if(strcmp(buffer,"deregister_engine_cognitive") == 0) {
-	    DeregisterCognitiveEngine(socketFD);
+        DeregisterCognitiveEngine(socketFD);
     } else if(strcmp(buffer,"register_engine_policy") == 0) {
-	    RegisterPolicyEngine(socketFD);
+        RegisterPolicyEngine(socketFD);
     } else if(strcmp(buffer,"deregister_engine_policy") == 0) {
-	    DeregisterPolicyEngine(socketFD);
+        DeregisterPolicyEngine(socketFD);
     } else if(strcmp(buffer,"register_sml") == 0) {
-	    RegisterSML(socketFD);
+        RegisterSML(socketFD);
     } else if(strcmp(buffer,"deregister_sml") == 0) {
-	    DeregisterSML(socketFD);
+        DeregisterSML(socketFD);
     } else if(strcmp(buffer,"optimize") == 0) {
-	    /* Receive optimization request and current environment */
-	    GetOptimalParameters(socketFD);  
+        /* Receive optimization request and current environment */
+        GetOptimalParameters(socketFD);  
     }
 }
@@ -407,16 +407,16 @@
 
     if(InitializeTCPServerPort(servSock[primary]) == -1) {
-	ERROR(1,"Error initializing primary port\n");
-       	return; 
+    ERROR(1,"Error initializing primary port\n");
+           return; 
     }
  
     if(InitializeTCPServerPort(servSock[policy]) == -1) {
-	ERROR(1,"Error initializing policy port\n");
-       	return; 
+    ERROR(1,"Error initializing policy port\n");
+           return; 
     }
 
     if(InitializeTCPServerPort(servSock[command]) == -1) { 
-	ERROR(1,"Error initializing command port\n");
-       	return; 
+    ERROR(1,"Error initializing command port\n");
+           return; 
     }
 
@@ -446,5 +446,5 @@
                 if (FD_ISSET(port, &sockSet))
                 {
-	            desc_ready -= 1;
+                desc_ready -= 1;
 
                     /* Check if request is new or on an existing open descriptor */