Index: /vtcross/trunk/src/lib/socketcomm/socketcomm.cpp
===================================================================
--- /vtcross/trunk/src/lib/socketcomm/socketcomm.cpp	(revision 227)
+++ /vtcross/trunk/src/lib/socketcomm/socketcomm.cpp	(revision 229)
@@ -44,5 +44,5 @@
         ERROR(1, "Error reading from socket.\n");
     if(msgLength == 0)
-        ERROR(1, "Remote component closed connection.\n");
+        ERROR(1, "Remote component closed connection. 1\n");
 
     size_t i;
@@ -57,5 +57,5 @@
         ERROR(1, "Error reading from socket.\n");
     if(msgLength == 0)
-        ERROR(1, "Remote component closed connection.\n");
+        ERROR(1, "Remote component closed connection. 2\n");
 }
 
@@ -124,5 +124,5 @@
     ssize_t numSentBytes = send(socketFD, message, (strlen(message) + 1), 0);
 	if(numSentBytes < 0) {
-        ERROR(1, "Error sending to server.\n");
+        ERROR(1, "Error sending to server %i (%i): %s\n",socketFD, numSentBytes, message);
     }
     else if(numSentBytes == 0) {
Index: /vtcross/trunk/src/shell/CognitiveRadioShell.cpp
===================================================================
--- /vtcross/trunk/src/shell/CognitiveRadioShell.cpp	(revision 228)
+++ /vtcross/trunk/src/shell/CognitiveRadioShell.cpp	(revision 229)
@@ -462,5 +462,5 @@
     memset(buffer, 0, 256);
     ReadMessage(commandSocketFD, buffer);
-    uint32_t numObservables = atoi(buffer);
+    numObservables = atoi(buffer);
   
 	LOG("Cognitive Radio Shell:: Attempting to get %i observables.\n", numObservables);
@@ -471,11 +471,10 @@
         ReadMessage(commandSocketFD, buffer);
         o[i].name = std::string(buffer);
-    
+   
         memset(buffer, 0, 256);
         ReadMessage(commandSocketFD, buffer);
         o[i].value = atof(buffer);
     }
-
-    /* Receive Set of Current Parameters */
+	/* Receive Set of Current Parameters */
     memset(buffer, 0, 256);
     ReadMessage(commandSocketFD,buffer);
@@ -484,10 +483,9 @@
 	LOG("Cognitive Radio Shell:: Attempting to get %i parameters.\n",numCurrentParameters);
     Parameter * cp = new Parameter[numCurrentParameters];
- 
-    for (i = 0; i < numCurrentParameters; i++){
+
+    for (size_t i = 0; i < numCurrentParameters; i++){
         memset(buffer, 0, 256);
         ReadMessage(commandSocketFD,buffer);
         cp[i].name = std::string(buffer);
-    
         memset(buffer, 0, 256);
         ReadMessage(commandSocketFD,buffer);
@@ -504,5 +502,5 @@
         sprintf(counter,"%i",numObservables);
         SendMessage(ceSocketFD,counter);
-        for(i = 0; i < numObservables; i++) {
+        for(size_t i = 0; i < numObservables; i++) {
             SendMessage(ceSocketFD,o[i].name.c_str());
             sprintf(var,"%f",o[i].value);
@@ -513,5 +511,5 @@
         sprintf(counter,"%i",numCurrentParameters);
         SendMessage(ceSocketFD,counter);
-        for(i = 0; i < numCurrentParameters; i++) {
+        for(size_t i = 0; i < numCurrentParameters; i++) {
             SendMessage(ceSocketFD,cp[i].name.c_str());
             sprintf(var,"%f",cp[i].value);
@@ -524,5 +522,5 @@
     memset(buffer, 0, 256);
     ReadMessage(ceSocketFD, buffer);
-    uint32_t numParameters = atoi(buffer);
+    numParameters = atoi(buffer);
    
     Parameter *p = new Parameter[numParameters];
Index: /vtcross/trunk/src/libvtcross/libvtcross.cpp
===================================================================
--- /vtcross/trunk/src/libvtcross/libvtcross.cpp	(revision 228)
+++ /vtcross/trunk/src/libvtcross/libvtcross.cpp	(revision 229)
@@ -76,17 +76,19 @@
     }
 
-    // Send Observables
+    // Send Parameters 
     memset(counter, 0, 55);
-    sprintf(counter,"%i",numCurrentParameters);
-    SendMessage(socketfd,counter);
-    for(i = 0; i < numCurrentParameters; i++) {
-        SendMessage(socketfd,currentParameters[i].name.c_str());
+    sprintf(counter, "%i", numCurrentParameters);
+    SendMessage(socketFD, counter);
+	
+	for(i = 0; i < numCurrentParameters; i++) {
+        SendMessage(socketFD,currentParameters[i].name.c_str());
         sprintf(var,"%f",currentParameters[i].value);
-        SendMessage(socketfd,var);	
+        SendMessage(socketFD,var);	
     }
+
     /* Receive Set of Parameters */
     memset(buffer, 0, 256);
     ReadMessage(socketFD, buffer);
-    int32_t numParameters = atoi(buffer);
+    numParameters = atoi(buffer);
     Parameter *pList = new Parameter[numParameters];
     