Index: /vtcross/trunk/src/lib/socketcomm/socketcomm.cpp
===================================================================
--- /vtcross/trunk/src/lib/socketcomm/socketcomm.cpp	(revision 229)
+++ /vtcross/trunk/src/lib/socketcomm/socketcomm.cpp	(revision 232)
@@ -48,5 +48,5 @@
     size_t i;
     for(i = 0; i < 256; i++) {
-	    if(strcmp(&msgBuffer[i], "\0") == 0)
+        if(strcmp(&msgBuffer[i], "\0") == 0)
             break;
     }
@@ -123,5 +123,5 @@
 {
     ssize_t numSentBytes = send(socketFD, message, (strlen(message) + 1), 0);
-	if(numSentBytes < 0) {
+    if(numSentBytes < 0) {
         ERROR(1, "Error sending to server %i (%i): %s\n",socketFD, numSentBytes, message);
     }
Index: /vtcross/trunk/src/shell/CognitiveRadioShell.cpp
===================================================================
--- /vtcross/trunk/src/shell/CognitiveRadioShell.cpp	(revision 231)
+++ /vtcross/trunk/src/shell/CognitiveRadioShell.cpp	(revision 232)
@@ -157,5 +157,5 @@
     for(size_t i = 0; i < radio_info->numObservables; i++) {
         SendMessage(socketFD, observables[i].name.c_str());
-		
+        
         sprintf(counter, "%i", observables[i].numAffects); 
         SendMessage(socketFD, counter);
@@ -165,5 +165,5 @@
         }
     }
-	
+    
     /* Receive ACK for radio configuration */
     char buffer[256];
@@ -185,5 +185,5 @@
     LOG("Cognitive Radio Shell:: Sending radio experience to Cognitive Engine.\n");
     int32_t numberExp = 4;
-	char numberExpString[50];
+    char numberExpString[50];
 
     sprintf(numberExpString, "%i", numberExp);
@@ -462,5 +462,5 @@
     uint32_t numObservables = atoi(buffer);
   
-	LOG("Cognitive Radio Shell:: Attempting to get %i observables.\n", numObservables);
+    LOG("Cognitive Radio Shell:: Attempting to get %i observables.\n", numObservables);
     Observable *o = new Observable[numObservables];
  
@@ -475,10 +475,10 @@
     }
 
-	/* Receive Set of Current Parameters */
+    /* Receive Set of Current Parameters */
     memset(buffer, 0, 256);
     ReadMessage(commandSocketFD,buffer);
     uint32_t numCurrentParameters = atoi(buffer);
   
-	LOG("Cognitive Radio Shell:: Attempting to get %i parameters.\n",numCurrentParameters);
+    LOG("Cognitive Radio Shell:: Attempting to get %i parameters.\n",numCurrentParameters);
     Parameter * cp = new Parameter[numCurrentParameters];
 
@@ -493,9 +493,9 @@
 
     /* Send to Cognitive Engine 
-	 * TODO: With multiple CEs we need to make a decision about where
-	 * to send this information
-	 */
-	if(!SML_present) { 
-	    LOG("Cognitive Radio Shell:: Passing on observables to Cognitive Engine\n");
+     * TODO: With multiple CEs we need to make a decision about where
+     * to send this information
+     */
+    if(!SML_present) { 
+        LOG("Cognitive Radio Shell:: Passing on observables to Cognitive Engine\n");
         SendMessage(ceSocketFD,"request_optimization");
         sprintf(counter,"%i",numObservables);
@@ -504,8 +504,8 @@
             SendMessage(ceSocketFD,o[i].name.c_str());
             sprintf(var,"%f",o[i].value);
-	        SendMessage(ceSocketFD,var);
+            SendMessage(ceSocketFD,var);
         }
-	    
-		LOG("Cognitive Radio Shell:: Passing on current parameters to Cognitive Engine\n");
+        
+        LOG("Cognitive Radio Shell:: Passing on current parameters to Cognitive Engine\n");
         sprintf(counter,"%i",numCurrentParameters);
         SendMessage(ceSocketFD,counter);
@@ -513,9 +513,9 @@
             SendMessage(ceSocketFD,cp[i].name.c_str());
             sprintf(var,"%f",cp[i].value);
-	        SendMessage(ceSocketFD,var);
+            SendMessage(ceSocketFD,var);
         }
-	}
-
-	LOG("Cognitive Radio Shell:: Receiving optimized parameters from Cognitive Engine.\n");
+    }
+
+    LOG("Cognitive Radio Shell:: Receiving optimized parameters from Cognitive Engine.\n");
     /* Receive Set of Parameters */
     memset(buffer, 0, 256);
@@ -536,6 +536,6 @@
 
     /* Send to Application 
-	 */
-	LOG("Cognitive Radio Shell:: Sending optimized parameters to Application.\n");
+     */
+    LOG("Cognitive Radio Shell:: Sending optimized parameters to Application.\n");
     memset(counter, 0, 55);
     sprintf(counter, "%i", numParameters);
@@ -544,5 +544,5 @@
         SendMessage(commandSocketFD, p[i].name.c_str());
         sprintf(var, "%f", p[i].value);
-	    SendMessage(commandSocketFD, var);
+        SendMessage(commandSocketFD, var);
     }
 
@@ -559,5 +559,5 @@
     char buffer[256];
 
-	/* Receive Set of Parameters */
+    /* Receive Set of Parameters */
     memset(buffer, 0, 256);
     ReadMessage(commandSocketFD,buffer);
@@ -644,14 +644,14 @@
         UpdateParameterPerformance(socketFD);
     } else if(strcmp(buffer, "get_number_utilities") == 0) {
-		char numUtilities[20];
-		sprintf(numUtilities, "%i", radio_info->numUtilities);
+        char numUtilities[20];
+        sprintf(numUtilities, "%i", radio_info->numUtilities);
         SendMessage(commandSocketFD, numUtilities);
     } else if(strcmp(buffer, "get_number_observables") == 0) {
-		char numObservables[20];
-		sprintf(numObservables, "%i", radio_info->numObservables);
+        char numObservables[20];
+        sprintf(numObservables, "%i", radio_info->numObservables);
         SendMessage(commandSocketFD, numObservables);
     } else if(strcmp(buffer, "get_number_parameters") == 0) {
-		char numParameters[20];
-		sprintf(numParameters, "%i", radio_info->numParameters);
+        char numParameters[20];
+        sprintf(numParameters, "%i", radio_info->numParameters);
         SendMessage(commandSocketFD, numParameters);
     } else if(strcmp(buffer, "request_optimization") == 0) {
@@ -686,11 +686,11 @@
     int32_t maxDescriptor; 
 
-	if(servSock[primary] > servSock[policy])
-		maxDescriptor = servSock[primary];
+    if(servSock[primary] > servSock[policy])
+        maxDescriptor = servSock[primary];
     else 
-		maxDescriptor = servSock[policy];
-
-	if(servSock[command] > maxDescriptor)
-		maxDescriptor = servSock[command];
+        maxDescriptor = servSock[policy];
+
+    if(servSock[command] > maxDescriptor)
+        maxDescriptor = servSock[command];
 
     if(InitializeTCPServerPort(servSock[primary]) == -1)
Index: /vtcross/trunk/src/libvtcross/libvtcross_demo.cpp
===================================================================
--- /vtcross/trunk/src/libvtcross/libvtcross_demo.cpp	(revision 231)
+++ /vtcross/trunk/src/libvtcross/libvtcross_demo.cpp	(revision 232)
@@ -23,5 +23,5 @@
 main(int32_t argc, char *argv[])
 {
-	for(size_t i = 0; i < 10; i++) {
+    for(size_t i = 0; i < 10; i++) {
         Observable *o = new Observable[2];
         Parameter *currentParameters = new Parameter[2];
@@ -62,11 +62,11 @@
         o[1].value = 15-p[1].value;
 
-        UpdateParameterPerformance(p, numParameters, o, numObservables);	
+        UpdateParameterPerformance(p, numParameters, o, numObservables);    
         
         delete [] p; 
         delete [] o; 
-	}
+    }
 
-	return 0;
+    return 0;
 }
 
Index: /vtcross/trunk/src/libvtcross/libvtcross.cpp
===================================================================
--- /vtcross/trunk/src/libvtcross/libvtcross.cpp	(revision 231)
+++ /vtcross/trunk/src/libvtcross/libvtcross.cpp	(revision 232)
@@ -22,5 +22,5 @@
 {
     // TODO why is this hardcoded like this??
-   	return ClientSocket("localhost", "40000");
+       return ClientSocket("localhost", "40000");
 }
 
@@ -38,6 +38,6 @@
     ReadMessage(socketfd, buffer);
     uint32_t numObservables = atoi(buffer);
-	
-	return numObservables; 
+    
+    return numObservables; 
 }
 
@@ -53,6 +53,6 @@
     ReadMessage(socketfd, buffer);
     uint32_t numUtilities = atoi(buffer);
-	
-	return numUtilities; 
+    
+    return numUtilities; 
 }
 
@@ -68,6 +68,6 @@
     ReadMessage(socketfd, buffer);
     uint32_t numParameters = atoi(buffer);
-	
-	return numParameters; 
+    
+    return numParameters; 
 }
 // end previous TODO
@@ -85,9 +85,9 @@
 Parameter* 
 GetOptimalParameters(Observable *radioObservables, uint32_t numObservables,
-		Parameter *currentParameters, uint32_t numCurrentParameters)
+        Parameter *currentParameters, uint32_t numCurrentParameters)
 {
     char var[50];
     char counter[55];
-	char buffer[256];
+    char buffer[256];
 
     uint32_t socketFD = ConnectToRemoteComponent();
@@ -104,5 +104,5 @@
         SendMessage(socketFD, radioObservables[i].name.c_str());
         sprintf(var, "%f", radioObservables[i].value);
-        SendMessage(socketFD, var);	
+        SendMessage(socketFD, var);    
     }
 
@@ -111,8 +111,8 @@
     sprintf(counter, "%i", numCurrentParameters);
     SendMessage(socketFD, counter);
-	for(size_t i = 0; i < numCurrentParameters; i++) {
+    for(size_t i = 0; i < numCurrentParameters; i++) {
         SendMessage(socketFD,currentParameters[i].name.c_str());
         sprintf(var,"%f",currentParameters[i].value);
-        SendMessage(socketFD,var);	
+        SendMessage(socketFD,var);    
     }
 
@@ -128,5 +128,5 @@
         pList[i].name = std::string(buffer);
         
-		memset(buffer, 0, 256);
+        memset(buffer, 0, 256);
         ReadMessage(socketFD, buffer);
         pList[i].value = atof(buffer);
@@ -138,7 +138,7 @@
 bool
 UpdateParameterPerformance(Parameter *p, uint32_t numParameters, Observable *o,
-		uint32_t numObservables)
+        uint32_t numObservables)
 {
-	char counter[55];
+    char counter[55];
     char var[50];
 
@@ -150,12 +150,12 @@
     sprintf(counter, "%i", numParameters);
     SendMessage(socketFD, counter);
-	
-	for(size_t i = 0; i < numParameters; i++) {
+    
+    for(size_t i = 0; i < numParameters; i++) {
         SendMessage(socketFD, p[i].name.c_str());
         sprintf(var, "%f", p[i].value);
-        SendMessage(socketFD, var);	
+        SendMessage(socketFD, var);    
     }
     
-	// Send Observables
+    // Send Observables
     sprintf(counter, "%i", numObservables);
     SendMessage(socketFD, counter);
@@ -163,5 +163,5 @@
         SendMessage(socketFD, o[i].name.c_str());
         sprintf(var, "%f", o[i].value);
-        SendMessage(socketFD, var);	
+        SendMessage(socketFD, var);    
     }
 }